<?php
// Библиотека рассылочника.
class RSS {
  
   
  /**
   *  Конструктор класса.
   */
  public function __construct() {   
    
  }
  
  /**
   * Возвращет единственный экземпляр данного класса.
   * @return object - объект класса 
   */
  static public function getInstance() {
    if (is_null(self::$_instance)) {
      self::$_instance = new self;
    }
    return self::$_instance;
  }
   /**
   * Инициализирует единственный объект данного класса
   * @return object 
   */
  public static function init() {
    self::getInstance();
  }

 
   /**
   * Сохраняет параметры rss рассылки
   * 
   */
  public static function saveRSS(
    $id,
    $rss_link,
    $active, 
    $html_template,
    $time_send,
    $list_id
    ) {
    $res = DB::query('SELECT id FROM `'.PREFIX.'rss` WHERE id = '.DB::quoteInt($id));
    
    if(!DB::fetchAssoc($res)){
  
      DB::query('
        INSERT INTO`'.PREFIX.'rss` (`id`,`rss_link`,`active`,`html_template`,`time_send`,`list_id`)
        VALUES ('.DB::quote($id).','
        .DB::quote($rss_link).','
        .DB::quote($active).','
        .DB::quote($html_template).','
        .DB::quote($time_send).','
        .DB::quote($list_id).')');
    }else{
    
       DB::query('
       UPDATE `'.PREFIX.'rss`
       SET `rss_link`  = '.DB::quote($rss_link).',
           `active` = '.DB::quote($active).',
           `html_template` = '.DB::quote($html_template).',
           `time_send` = '.DB::quote($time_send).',
           `list_id` = '.DB::quote($list_id).'
       WHERE `id` = '.DB::quoteInt($id)) ;
          
    }
  }
  

  public static function getRSSlist() {
    $result = null;
    $res = DB::query('SELECT * FROM `'.PREFIX.'rss` WHERE 1=1 ORDER BY id DESC');
    while ($row = DB::fetchAssoc($res)) {
      $result[$row['id']] = $row;
    }
    return $result;
  }

  public static function getRSSlistToCrone() {    
    $result = array();

    $listIdRSS = RSS::getRssToRead();

    if(empty($listIdRSS)) {
      LOG::write('Отсутствуют RSS для чтения в данный момент');
      return array();
    }

    $listIdRSS  = implode(',',$listIdRSS);

    $res = DB::query('SELECT * FROM `'.PREFIX.'rss` WHERE id IN ('.DB::quote($listIdRSS,1).') ORDER BY id DESC');
    while ($row = DB::fetchAssoc($res)) {
      $result[$row['id']] = $row;
    }

    return $result;
  }


  
  static function deleteRSS($id){
    DB::query("
      DELETE FROM `".PREFIX."rss` WHERE id = ".DB::quoteInt($id)
    );
  }
  
  static function addRSS(){
       DB::query('
        INSERT INTO`'.PREFIX.'rss` (`id`)
        VALUES ("")');
       
  }
  
  public function readRss($link){
    $link="https://moguta.ru/blog/rss";
    $rss = simplexml_load_file($link);
    if($rss){
      LOG::write('RSS успешно считан: '.$link);
    //  echo '<h1>'.$rss->channel->title.'</h1>';
     // echo '<li>'.$rss->channel->pubDate.'</li>';
      $items = $rss->channel->item;
      $i =0;
      foreach($items as $item){
        if($i) continue;
        $i=1;
        $title = $item->title;
        $link = $item->link;
        $published_on = $item->pubDate;
        $description = $item->description;
   //     echo '<h3><a href="'.$link.'">'.$title.'</a></h3>';
   //     echo '<span>('.$published_on.')</span>';
   //     echo '<p>'.$description.'</p>';
      }
    }else{
      LOG::write('Не удалось считать RSS канал: '.$link, 2);
    }
  } 

  /*
  * возвращает данные по последнему сообщению в ленте
  */
  public function getLastRssLetter($id, $link, $htm_template){
    $result = array();


    $rss = simplexml_load_file($link);
    if($rss){
      LOG::write('RSS успешно считан: '.$link);
      // если канал можно читать, то заменяем дату последнего чтения на сегодняшню у этого канала
      DB::query("
        UPDATE `".PREFIX."rss`
        SET `read_today`=(CAST(CAST(NOW() AS date) as DATETIME)) 
        WHERE id = ".DB::quote($id)
      );

      $pos = strpos($htm_template, '[RSS:DESC]');
      if ($pos === false) {
        LOG::write('Не обнаружено маски [RSS:DESC] в шаблоне для канала: '.$link,3);
      } 
      $pos = strpos($htm_template, '[RSS:TITLE]');
      if ($pos === false) {
        LOG::write('Не обнаружено маски [RSS:TITLE] в шаблоне для канала: '.$link,3);
      }      

      $result['title_rss'] = $rss->channel->title;  
      $items = $rss->channel->item;
      $i =0;
      foreach($items as $item){
        if($i) continue;
        $i=1;      
        $result['title'] = $item->title;
        $result['link'] = $item->link;
        $result['pubDate'] = $item->pubDate;
        $result['description'] = $item->description;
        $result['description'] = str_replace('[RSS:DESC]', $result['description'], $htm_template);
        $result['description'] = str_replace('[RSS:TITLE]', $result['title'], $result['description']);
        $result['description'] = str_replace('[RSS:LINK]', $result['link'], $result['description']);
        $result['description'] = str_replace('[RSS:DATE]', $result['pubDate'], $result['description']);
     }      
    }else{
      LOG::write('Не удалось считать RSS канал: '.$link, 2);
    }
    return $result;
  }

   public function  alreadyExistLetterRss($item){
    $res = DB::query('SELECT * FROM `'.PREFIX.'letter`
    WHERE `title`='.DB::quote($item['title']).' and `rss_pub`='.DB::quote($item['pubDate']));
    if ($row = DB::fetchAssoc($res)) {   
     return true;
    }
    return false;
   }

   // возвращает список RSS каналов для чтения
   public function  getRssToRead(){
    $result = array();
      /*
      Запрос для наглядной отладки
      SELECT `time_send`, `read_today`, now(), 
      CAST(CAST(NOW() AS date) as DATETIME) as 'cudate',
      (ADDDATE(CAST(CAST(NOW() AS date) as DATETIME), INTERVAL `time_send` HOUR_MINUTE)) as 'cur_plus_time',
      (ADDDATE(CAST(CAST(NOW() AS date) as DATETIME), INTERVAL `time_send` HOUR_MINUTE) < now()) as 'bool_compare_now'
      FROM `mg1_rss` WHERE 1
      */
    // в базе ищем каналы, которые нужно считать
    // условие:
    // если дата последнего чтения вчерашняя или раннее, то канал может быть прочитан
    // если заданное время отправки меньше текущего часа, то канал не читать.
    // Читать каналы только те которые сегодня не читались и текущее время больше либо равно заданному в настройках  
    $res = DB::query("SELECT * 
      FROM `".PREFIX."rss` 
      WHERE (ADDDATE(CAST(CAST(NOW() AS date) as DATETIME), INTERVAL `time_send` HOUR_MINUTE) < now()) 
      AND (ADDDATE(`read_today`, INTERVAL '1' DAY) <= NOW())"
    ); 
    
    while ($row = DB::fetchAssoc($res)) {
    
       LOG::write('RSS будет прочитан: '.$row['rss_link']);
      // собираем все id каналов доступных для чтения
      $result[] = $row['id'];
    
    }

    return  $result;
   }
}
