// массив подключенных скриптов, для избежания дублей
var javascripts = [];

// главный модуль админки, управляет всем остальным, включает в себя ряд полезных функций используемы повсеместно.
var admin = (function () {

  return {
    SITE: "null", // домен сайта
    SECTION: "null", // страница по умолчанию
    WAIT_PROCESS: false, // процесс загрузки
    WAIT_DELAY: 300, // количество милисекунд, которое должно пройти между запросом и получением ответа чтобы показать лоадер
  
    /**
     * Инициализация компонентов админки
     */
    init: function() {
      // Домен сайта
      this.SITE = mgBaseDir;      
      $('body').on('click', '.reveal-modal-bg', function(e){
        e.preventDefault();
        return false;
      })
      //Подключаем файл, в котором содержится обработка частых ошибок.
      includeJS(admin.SITE + '/mg-core/script/admin/errors.js');

      // Запуск крона на сборку писем и формирование очереди
      $('body').on('click','.temp-as-cron', function(){
         admin.ajaxRequest({
          mguniqueurl:"action/startCron"   
         },
         function(response) {
          admin.indication(response.status, response.msg);
          admin.show(admin.SECTION+".php","adminpage");
         }
        );
      });

      // клик по сообщению о доступной новой версии
      $('body').on('click', '#newVersion, #fakeKey', function () {
        $('a[id=settings]').click();
        // после перехода выполняем два отложенных метода
        admin.AJAXCALLBACK = [
          {callback: 'settings.openSystemTab', param: null},
        ];
      });

      $('body').on('click', '#timeInfo .close-timeinfo', function () {
         var expires = new Date();
         expires.setTime(expires.getTime() + (1 * 24 * 60 * 60 * 1000));//1 день
         document.cookie = 'timeinfo_closed=1;expires=' + expires.toUTCString()+"; path=/";
         $('#timeInfo').hide();
      });

      // Запуск крона на отправку писем из очереди
      $('body').on('click','.temp-as-cron-send', function(){
         admin.ajaxRequest({
          mguniqueurl:"action/sendEmailCron"   
         },
         function(response) {
          admin.indication(response.status, response.msg);
          admin.show(admin.SECTION+".php","adminpage");
         }
        );
      });
      

      // обработчик нажатия на основные табы админки
      $('.head-menu-btn').click(function(){
	var nameSection = $(this).attr('id');
        admin.SECTION = nameSection;
        admin.show(nameSection+".php","adminpage", cookie(admin.SECTION + "_getparam"));
        includeJS(mgBaseDir+'/mg-core/script/admin/'+nameSection+'.js');
      });


      // обработчик закрытия окна uploader
      $('body').on('click', '.uploader-modal_close', function () {
        admin.closeModal($(this).closest('.uploader-modal'));
      });

      // обработчик для нажатий на навигацию страниц
      // вешается на тело страницы, и отрабатывает с любого раздела
      $('body').on('click','.linkPage', function(){
        var pageId = admin.getIdByPrefixClass($(this), 'page');
        // открываем выбранную страницу, текущего раздела     
        // если на странице присутствуют фильтры учитываем их в пагинации
        var request = $("form[name=filter]").formSerialize();
        var getparam = "page=" + pageId + "&" + request;
        var displayFilter = '';
        if ($(".filter-container").css('display') == 'block') {
          displayFilter = '&displayFilter=1';
        }
        admin.show(admin.SECTION+".php", cookie("type"), getparam + displayFilter);       
      });
   
      // Восстанавливаем  последний открытый раздел
      this.refreshPanel();
    

      // при смене значения чекбокса записываем в value, чтобы потом получать данные
      $('body').on('click', 'input[type="checkbox"]', function(){
         $(this).val($(this).prop('checked'));
      });

      // проверка поля на численное значение
      $('body').on('keyup', '.numericProtection', function(){
        if(isNaN($(this).val()) || $(this).val()<=0 ){
          $(this).val('1');
        }
      });
   
      // вешаем класс active на выбранный таб в меню
      $('.head-menu-btn').click(function(){
        admin.activeTab($(this).attr('id'));
      });
      
      $('body').on('click, focus', 'input[name=url]', function () {
        if ($('input[name=url]').val() == '') {
          var text = $('.tite2url').val();
          if (text) {
            text.replace('%', '-');
            text = admin.urlLit(text, 1);
            $(this).val(text);
          }
        }
      });

       // Устанавливает количество выводимых записей в открытом разделе.
      $('.admin-center').on('change', '.countRowsToSection', function(){
        var count = $(this).val();
        var section = $(this).data('section');
        admin.ajaxRequest({
          mguniqueurl: "action/setCountRows",
          count: count,
          section: section,
        },
        function(response) {
          var request = $("form[name=filter]").formSerialize(); 
          var displayFilter = '';
          if ($(".filter-container").css('display') == 'block') {
            displayFilter = '&displayFilter=1';
          }
          admin.show("emailbase.php","adminpage",request+displayFilter);
        }
        );

      });

$(function(){
       /* $.when(
          admin.getSettingFromDB('sessionToDB'),
          admin.getSettingFromDB('sessionAutoUpdate')
        ).then(function(sessionToDBResp, sessionAutoUpdateResp, sessionLifeTimeResp) {
          var sessionToDB = sessionToDBResp[0].data.sessionToDB;
          var sessionAutoUpdate = sessionAutoUpdateResp[0].data.sessionAutoUpdate;
*/
          var sessionToDB = 'false';
          var sessionAutoUpdate = 'true';
      
            if (sessionAutoUpdate != 'false') {
              setInterval(function() {
                admin.ajaxRequest({
                  mguniqueurl: "action/updateSession",
                },
                function (response) {
                });
              }, (3600/2*1000)); // через 5 минут автопродливать сессию
            } else {
              admin.startCountDown();
            }
        
        //});
      });
      
      $('body').on('click', '.session-info.alert', function(){
        admin.ajaxRequest({
          mguniqueurl: "action/updateSession",
        }, function (response) {
          $('.session-info').remove();
          $('.session-info-overlay').remove();
          admin.TIME_WITHOUT_USER = 0;
        });
      });
      
      $('body').on('click', '.session-info .session-info-close', function(){
        $('.session-info').remove();
        $('.session-info-overlay').remove();
        admin.TIME_WITHOUT_USER = 0;
      });
    

    },
    // вешаем класс active на выбранный таб в меню
    // idTab - название секции 
    activeTab: function(idTab) {   
        $('.top-bar-section li').removeClass('active');       
        $('#'+idTab).parent('li').addClass('active');            
        
    },
   
    /**
     * При обновлении страницы, восстанавливает открытый раздел
     */
    refreshPanel: function() {

      // открыть последний активный раздел, считывается с куков
      this.SECTION = cookie("section");

      // если куки пусты то открывается первый раздел - статистика
      if(!this.SECTION){
        this.SECTION="emailbase";
      }      
     
      $('a[id='+this.SECTION+']').click();     
      // делаем пункт выбранным    
      admin.activeTab(this.SECTION);
      
    },



   /**
     * Индикатор сообщений
     * Функция выводит информацию об успешности или ошибки 
     * различных действия администратора в админке.
     */
    indication: function (status, text) {

      $('.message-error').remove();
      $('.message-succes').remove();
      var object = "";
      switch (status) {
        case 'succes':
        {
          $('body').append('<div class="message-succes"></div>');
          object = $('.message-succes');
          break;
        }
        case 'error':
        {
          $('body').append('<div class="message-error"></div>');
          object = $('.message-error');
          break;
        }
        default:
        {
          $('body').append('<div class="message-error"></div>');
          object = $('.message-error');
          break;
        }
      }

      object.slideDown("fast");
      object.html(text);
      setTimeout(function () {
        object.remove();
      }, 3000);
    },

  /**
     * Обертка для всех аякс запросов админки
     * необходимо для оптимизации вывода процесса загрузки
     * и унификации всех аякс вызовов
     */
    ajaxRequest: function (data, callBack, loader, dataType, noAlign) {

      if (!dataType)
        dataType = 'json';
      if (!loader)
        loader = $('.mailLoader');

      $.ajax({
        type: "POST",
        url: "ajax",
        data: data,
        cache: false,
        dataType: dataType,
        success: callBack,
        beforeSend: function () {
          // флаг, говорит о том что начался процесс загрузки с сервера
          admin.WAIT_PROCESS = true;
          loader.hide();
          loader.before('<div class="view-action" style="margin-top:-2px;">Ожидайте идет загрузка</div>');
          // через 300 msec отобразится лоадер.
          // Задержка нужна для того чтобы не мерцать лоадером на быстрых серверах.
          setTimeout(function () {
            if (admin.WAIT_PROCESS) {
              admin.waiting(true);
            }
          }, admin.WAIT_DELAY);
        },
        complete: function () {
    
          // завершился процесс
          admin.WAIT_PROCESS = false;
          //прячем лоадер если он успел появиться
          admin.waiting(false);
          loader.show();
          $('.view-action').remove();

          if ($('.b-modal').length > 0 && !noAlign) {
            admin.centerPosition($('.b-modal'));
          }

          // выполнение стека отложенных функций после AJAX вызова    
          if (admin.AJAXCALLBACK) {
            //debugger;
            admin.AJAXCALLBACK.forEach(function (element, index, arr) {
              eval(element.callback).apply(this, element.param);
            });
            admin.AJAXCALLBACK = null;
          }
        },
        error: function (request, status, error) {
          if ($('.session-info').html()) {
            sessInfoText = "<div class='help-text'>"+lang.USER_NOT_ACTIVE+" "
                +"<strong>" + Math.round(admin.SESSION_LIFE_TIME/60) + "</strong> "+lang.MINUTES+" <br />"
                +lang.SESSION_CLOSED+"</div>"
                +"<form method='POST' action='" + admin.SITE + "/enter'>"
                +"<ul class='form-list'><li><span>" + lang.EMAIL + ":</span>"
                +"<input type='text' name='email'></li>"
                +"<li><span>" + lang.PASS + ":</span>"
                +"<input type='password' name='pass'></li></ul>"
                +"<button type='submit' class='default-btn'>" + lang.LOGIN + "</button></form>";
            $('.session-info').html(sessInfoText);
            $('.session-info').removeClass('alert');
            clearInterval(admin.SESSION_CHECK_INTERVAL);
            return false;
          }

          errors.showErrorBlock(request.responseText);
        }
      });

    },

    /**
     * Открывает выбранный раздел админки
     * url - задает контролер, который будет обрабатывать запрос
     * type - тип (adminpage|plugin) разделяющий запросы по логике обработки движком. Запросы со страниц плагинов обрабатываются иначе.
     * request - сериализованные данные с форм использующихся в плагинах
     */
    show: function(url, type, request, callback){
      // Устанавливаем в куки название открываемого раздела
      var sect = url.split('.');
      cookie("section", sect[0]);
      cookie("type", type);
      cookie(admin.SECTION + "_getparam", request);
     // флаг, говорит о том что начался процесс загрузки с сервера
     admin.WAIT_PROCESS=true;

     // через 300 msec отобразится лоадер.
     // Задержка нужна для того чтобы не мерцать лоадером на быстрых серверах.
     setTimeout(function(){
       if(admin.WAIT_PROCESS){
         admin.waiting(true);
       }
     }, admin.WAIT_DELAY);

      // подготвка параметров для отправки
      var data = "mguniqueurl="+url+"&mguniquetype="+type+"&"+request;
      // console.log(data);
  
      $.ajax({
        type: "POST",
        url: "ajax",
        data: data,
        cache: false,
        success: function(data){
          $(".admin-center .data").html(data);

          if(callback){
            callback.call();
          }
          //admin.initCustom();

          // завешился процесс
          admin.WAIT_PROCESS=false;

          //прячим лоадер если он успел появиться
          admin.waiting(false);        
          if ($('[data-tooltip]').length){
            if($('.tooltip').length != 0) {                 
              $('.tooltip').remove();         
            }          
            $(".admin-center .data").foundation();
            $("[data-tooltip]").foundation("tooltip");  
          }
        }
      });
    },

    /**
     * Чистит куки хранящие в себе гет параметры для раздела
     */
    clearGetParam: function (run) {
      cookie(admin.SECTION + "_getparam", null);
    },

    /**
     *Если спустя секунду данные небыли получены, то выводим лоадер
     */
    waiting: function(run){
        run?$(".view-action").show():$(".view-action").hide();
    },

    /**
     *  Получает id по префиксу класса.
     *  Наприемр есть такой элемент:
     *  <a class='linkPage navButton page_501 link_2' href='#' >
     *  Задача: получить число 501 (идентификатор страницы)
     *  Вызова данной функции getIdByPrefixClass('.linkPage', 'page')
     *  вернет число 501
     */
    getIdByPrefixClass: function(obj, prefix){
      var result = null;
      var classList = obj.attr('class').split(/\s+/);
      var reg = new RegExp(prefix+'_(.*)');
      $.each(classList, function(index, item){
        var id = item.match(reg);
        if(id !== null)
          result = id[1];
      });
      return result;
    },

  
    /**
     * Транслитирирует строку
     */
    urlLit:function(w,v) {
      var tr='a b v g d e ["zh","j"] z i y k l m n o p r s t u f h c ch sh ["shh","shch"] ~ y ~ e yu ya ~ ["jo","e"]'.split(' ');
      var ww='';
      w=w.toLowerCase();
      for(i=0; i<w.length; ++i) {
        cc=w.charCodeAt(i);
        ch=(cc>=1072?tr[cc-1072]:w[i]);
        if(ch.length<3) ww+=ch; else ww+=eval(ch)[v];
      }
      return(ww.replace(/[^a-zA-Z0-9\-]/g,'-').replace(/[-]{2,}/gim, '-').replace( /^\-+/g, '').replace( /\-+$/g, ''));
    },


    /**
     * Шаблоны регулярных выражений
     */
   regTest: function(regId, text){
      switch (regId) {
        case 1:{
          return /^[-0-9a-zA-Zа-яА-ЯёЁ\s_\"\.!]+$/.test(text);
          break;
        }
        case 2:{
          return /^[-0-9a-zA-Zа-яА-ЯёЁ\s_]+$/.test(text);
          break;
        }
      }
    },
    
     /**
     * Показывает модальное окно файлового менеджера для загрузки файлов
     * @returns {undefined}
     */
    openUploader: function (callback, param, dir) {
       
     
      uploader.open(callback, param);
     
      admin.DIR_FILEMANAGER = 'uploads';
    },  

    /**
     * Позиционирует элемент по центру окна браузера
     */
    centerPosition: function (object) {
      object.css('position', 'absolute');
      var top = ($(window).height() - object.height()) / 2;
      if (top < 0) {
        top = 20;
      }
      object.css('left', ($(document).width() - object.width()) / 2 + 'px');
      object.css('top', top + (document.body.scrollTop || document.documentElement.scrollTop) + 'px');
      },
    /**
     * Открывает модальное окно
     */
    openModal: function (object) {
      admin.overlay();
      object.fadeIn(300);
      object.css({'position': 'fixed'});
      admin.centerPosition(object);
      $('.admin-footer-block').css({'position': 'fixed', 'width': '100%', 'bottom': '0'});
    },

    /**
     * Закрывает модальное окно
     */
    closeModal: function (object) {
      object.fadeOut(300);
      $("#overlay").eq($("#overlay").length - 1).remove();
      $('.admin-footer-block').css({'position': 'static', 'width': 'auto', 'bottom': '0'});
      $("body").removeClass("mg-lock");
    },
    
    /**
     * Фон для заднего плана при открытии всплывающего окна
     */
    overlay: function () {
      var docHeight = $(document).height();
      $("body").append("<div id='overlay' class='no-print'></div>");
      $("#overlay").height(docHeight);
    },
    startCountDown: function() {
      admin.SESSION_CHECK_INTERVAL = setInterval(function() {
        admin.ajaxRequest({
          mguniqueurl: "action/getSessionLifeTime",
          a: 'ping'
        }, function (response) {
          admin.TIME_WITHOUT_USER = response.data.timeWithoutUser;
          
          if (response.data.sessionLifeTime <= 300) {
            var sessInfo = $('div.session-info .sess-info-body');
            var sessInfoText = 
                "<div>"+lang.USER_NOT_ACTIVE+" <strong>" 
                + Math.floor(admin.TIME_WITHOUT_USER/60) + "</strong> "+lang.MINUTES+"<br /> "+lang.SESSION_END_COUNT+" <strong>"
                + Math.ceil(response.data.sessionLifeTime/60)+"</strong> "+lang.MINUTES+"</div>";

            if (response.data.sessionLifeTime <= 0) {
              sessInfoText = "<div class='help-text'>"+lang.USER_NOT_ACTIVE+" "
                +"<strong>" + Math.round(admin.SESSION_LIFE_TIME/60) + "</strong> "+lang.MINUTES+" <br />"
                +lang.SESSION_CLOSED+"</div>"
                +"<form method='POST' action='" + admin.SITE + "/enter'>"
                +"<ul class='form-list'><li><span>" + lang.EMAIL + ":</span>"
                +"<input type='text' name='email'></li>"
                +"<li><span>" + lang.PASS + ":</span>"
                +"<input type='password' name='pass'></li></ul>"
                +"<button type='submit' class='default-btn'>" + lang.LOGIN + "</button></form>";
              sessInfo.html(sessInfoText);
              sessInfo.parent('.session-info').removeClass('alert');
              clearInterval(admin.SESSION_CHECK_INTERVAL);
            }

            if (sessInfo.length) {
              sessInfo.html(sessInfoText);
            } else {
              $('body').append("<div class='session-info-overlay'>"
                  +"</div><div class='session-info alert'>"
                  +"<a href='javascript:void(0);' class='session-info-close' "
                  +"title='" + lang.CLOSE + "'>x</a>"
                  +"<div class='sess-info-header'>Moguta.CMS</div>"
                  +"<div class='sess-info-body'>" + sessInfoText + "</div>"
                  +"</div>");
            }
          }
        });

        admin.TIME_WITHOUT_USER+=60;
      }, 60000);
    },

  };
})();
  //функция для работы с куками
  function cookie(name, value, options) {
    if (typeof value != 'undefined') {
      options = options || {};
      if (value === null) {
        value = '';
        options.expires = -1;
      }
      var expires = '';
      if (options.expires && (typeof options.expires == 'number' || options.expires.toUTCString)) {
        var date;
        if (typeof options.expires == 'number') {
          date = new Date();
          date.setTime(date.getTime() + (options.expires * 24 * 60 * 60 * 1000));
        } else {
          date = options.expires;
        }
        expires = '; expires=' + date.toUTCString();
      }

      var path = options.path ? '; path=' + (options.path) : '';
      var domain = options.domain ? '; domain=' + (options.domain) : '';
      var secure = options.secure ? '; secure' : '';
      document.cookie = [name, '=', encodeURIComponent(value), expires, path, domain, secure].join('');
    } else {
      var cookieValue = null;
      if (document.cookie && document.cookie != '') {
        var cookies = document.cookie.split(';');
        for (var i = 0; i < cookies.length; i++) {
          var cookie = jQuery.trim(cookies[i]);
           if (cookie.substring(0, name.length + 1) == (name + '=')) {
            cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
            break;
          }
        }
      }
      return cookieValue;
    }
  };

/**
 * подключает javascript файл и выполняет его
 * заносит название файла в реестр подключенных,
 * дабы не дублировать
 */
function includeJS (path) {
  //alert('пробуем подключить'+path);
  for (var i=0; i<javascripts.length; i++) {
    if(path == javascripts[i]){
      // alert('JavaScript: ['+path+'] уже был подключен ранее!');
      return false;
    }
  }
  javascripts.push(path);
  $.ajax({
     url: path,
     dataType: "script",// при типе script JS сам инклюдится и воспроизводится без eval
     async: false
   });

}

$(document).ready(function(){
  includeJS(mgBaseDir + '/mg-admin/locales/ru_RU.js');
   // все скрипты в админке нужно подключать через функцию includeJS,
  includeJS(mgBaseDir+'/mg-core/script/jquery-ui-1.10.3.custom.min.js');
  includeJS(mgBaseDir + '/mg-core/script/jquery.form.js');
  window.CKEDITOR_BASEPATH = mgBaseDir+"/mg-core/script/ckeditor/";
  includeJS(mgBaseDir + '/mg-core/script/ckeditor/ckeditor.js?rev=12052016');  
  includeJS(mgBaseDir + '/mg-core/script/ckeditor/adapters/jquery.js');
  includeJS(mgBaseDir + '/mg-core/script/elfinder/js/elfinder.min.js');
  includeJS(mgBaseDir + '/mg-core/script/elfinder/js/i18n/elfinder.ru.js');
  includeJS(mgBaseDir + '/mg-core/script/admin/uploader.js');
  includeJS(mgBaseDir + '/mg-core/script/jquery-ui-timepicker-addon.js');
  
  admin.init();
});
